/*
**  LinVPN 1.2
**  Copyright (C) 2001 Alex Fiori <alex@linuxbr.com>
**
**  This program is free software; you can redistribute it and/or
**  modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2
**  of the License, or (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307
**  USA, or contact Alex Fiori <alex@linuxbr.com>
*/

#include <pwd.h>
#include <grp.h>
#include <stdio.h>
#include <unistd.h>

#ifndef USER
#error "See documentation.
#endif
#ifndef GROUP
#error "See documentation.
#endif

int main (int argc, char **argv)
{
	struct group  *grp;
	struct passwd *pwd;
	
	if (argc == 1) {
		fprintf (stderr, "usage: %s command\n", *argv);
		return 1;
	}

	pwd = getpwnam (USER);
	grp = getgrnam (GROUP);

	if (pwd == NULL || grp == NULL) {
		fprintf (stderr, "Fatal error, exiting.\n");
		return 1;
	}

	/* security! */
	if (pwd->pw_uid != getuid ()) {
		fprintf (stderr, "You're not user %s!\n", USER);
		return 1;
	}

	if (grp->gr_gid != getgid ()) {
		fprintf (stderr, "You're not on the group %s!\n", GROUP);
		return 1;
	}

	setuid (0);
	if (getuid ()) {
		fprintf (stderr, "Invalid uid: %d\n", getuid ());
		fprintf (stderr, "%s must be suid root, exiting.\n", *argv);
		return 1;
	}

	/* wrap! */
	execvp (argv[1], &argv[1]);
	perror ("exec");

	return 1;
}
